'*******************************************************************************
'*   TFormDesigner v 1.0
'*   Dialect : RapidQ
'*   Copyright (c) 2008-2009 Nastase Eodor
'*   eodor_nastase@yahoo.com
'*   rqwork.evonet.ro
'*   freeware
'*******************************************************************************

Declare Sub DrawGrid Lib "IDE.dll" Alias "DRAWGRID@16"(Dc&,GridX&,GridY&,GridColor&)

InitCommonControls

$Define clsClassName   1
$Define clsAncestor    2
$Define clsProc        3
$Define clsExStyle     4
$Define clsStyle       5
$Define clsCx          6
$Define clsCy          7
$Define clsAcceptCtrls 8
$Define clsPaintProc   9
$Define clsPropList    10

Type TList
     Count As Integer
     Items As Integer  'Pointer to an array of integer
End Type

Type TProperty
     Name    As Integer  'String Pointer
     Value   As Single
     Kind    As Integer
     Display As Integer 'String Pointer
     Access  As Integer
     Editor  As Integer
     Sets    As Integer  'TList Pointer
     Enums   As Integer  'TList Pointer
     Let     As Integer
     Get     As Integer
End Type

Type TClass
     ClassName   As Integer  'String Pointer
     Ancestor    As Integer  'String Pointer
     Proc        As Integer
     ExStyle     As Integer
     Style       As Integer
     Cx          As Integer
     Cy          As Integer
     BackColor   As Integer
     PaintProc   As Integer
     AcceptCtrls As Integer
     PropList    As Integer  'TList Pointer
End Type

Type TControl
     Handle   As Integer
     Parent   As Integer
     Controls As Integer
     PropList As Integer
     Assigned As Integer
End Type

Type TFont
     ClassName As Integer
     Handle    As Integer
     Name      As Integer
     Size      As Integer
     Bold      As Integer
     Italic    As Integer
     Underline As Integer
     Strikeout As Integer
     Charset   As Integer
     Color     As Integer
End Type

Sub NullPaint(hWnd&,Dc&,cx&,cy&,Text$)
    'Do nothing
End Sub

ReDim PaintProcs(1) As Integer
Bind PaintProcs(0) To NullPaint

Dim DefProc       As Integer
Dim SuperProc     As Integer
Dim ClassList()   As Integer
Dim ControlCount  As Integer
Dim ControlList() As Integer

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Declare Sub SetPropValue(hWnd&,PropName$,PropValue As Variant)
Declare Function GetPropValue(hWnd&,PropName$) As Variant
Declare Sub RegisterPropertyLetHandler(ClassName$,PropertyName$,HandlerID&)

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function FontCreate(Name As String, Size As Integer,Bold As Integer,Italic As Integer,Underline As Integer,Strikeout As Integer,Charset As Integer) As Integer
    Dim F As TFont
    DefInt FBolds(2) = {400,700},Dc,CyPixels
    Dc = GetDC(HWND_DESKTOP)
    CyPixels = GetDeviceCaps(DC, LOGPIXELSY)
    ReleaseDC(HWND_DESKTOP,DC)
    CharSet = IIf(CharSet,CharSet,DEFAULT_CHARSET)
    Size    = IIf(Size,Size,8)
    Name    = IIf(Name <> "",Name,"Tahoma")
    F.Handle    = CreateFont(-MulDiv(Size,CyPixels,72),0,0,0,FBolds(Bold),Italic,Underline,Strikeout,CharSet,OUT_TT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,FF_DONTCARE,Name)
    F.ClassName = NewZStr("QFont")
    F.Name      = NewZStr(Name)
    F.Size      = Size
    F.Bold      = Bold
    F.Italic    = Italic
    F.Underline = Underline
    F.Strikeout = Strikeout
    F.Charset   = Charset
    Result = NewPtr(SizeOf(F),F)
End Function

Function GetWndExtra(hWnd&,Offset&) As Integer
    Result = GetClassLong(hWnd&,GCL_CBWNDEXTRA)- Offset&
End Function

Sub GetChildControls(hWnd&)
    Dim Ctrl As TControl
    Dim List As TList
    ReDim Ctrls(0) As Integer
    MemSet List,0,SizeOf(List)
    MemSet Ctrl,0,SizeOf(Ctrl)
    DefInt i,PtrCtrl = GetWindowLong(hWnd&,GetWndExtra(hWnd&,8))
    If PtrCtrl Then
       MemCpy Ctrl,PtrCtrl,SizeOf(Ctrl)
       If Ctrl.Controls Then
          MemCpy List,Ctrl.Controls,SizeOf(List)
          ReDim ControlList(List.Count) As Integer
          ReDim Ctrls(List.Count) As Integer
          MemCpy VarPTR(Ctrls(0)),List.Items,SizeOf(Integer)*List.Count
          For i = List.Count -1 To 0 Step -1
              MemCpy Ctrl,Ctrls(i),SizeOf(Ctrl)
              ControlList(i) = Ctrl.Handle
          Next i
          ControlCount = List.Count
        End If
    End If
End Sub

Sub GetControls(hWnd&)
    Dim Ctrl As TControl
    Dim List As TList
    DefInt i,PtrCtrl = GetWindowLong(hWnd&,GetWndExtra(hWnd&,4))
    If PtrCtrl Then
       MemCpy Ctrl,PtrCtrl,SizeOf(Ctrl)
       If Ctrl.Controls Then
          MemCpy List,Ctrl.Controls,SizeOf(List)
          ReDim ControlList(List.Count) As Integer
          ReDim Ctrls(List.Count) As Integer
          MemCpy VarPTR(Ctrls(0)),List.Items,SizeOf(Integer)*List.Count
          For i = List.Count -1 To 0 Step -1
              MemCpy Ctrl,Ctrls(i),SizeOf(Ctrl)
              ControlList(i) = Ctrl.Handle
          Next i
          ControlCount = List.Count
        End If
    End If
End Sub

Function PropertyExists(hWnd&,PropName$) As Integer
    Dim L As TList
    Dim P As TProperty
    Dim C As TControl
    DefInt i,PList,PCtrl = GetWindowLong(hWnd&,GetWndExtra(hWnd&,4))
    Result = 0
    If PCtrl Then
       MemCpy C,PCtrl,SizeOf(C)
       If C.PropList Then
          MemCpy L,C.PropList,SizeOf(L)
          ReDim Properties(L.Count) As Integer
          MemCpy VarPTR(Properties(0)),L.Items,SizeOf(Integer)*L.Count
          For i = 0 To L.Count -1
              MemCpy P,Properties(i),SizeOf(P)
              If UCase$(StrFromPtr(P.Name) -Chr$(0)) = UCase$(PropName$) Then
                 Result = Properties(i)
                 Exit For
              End If
          Next i
       End If
    End If
End Function

Sub SetPropValue(hWnd&,PropName$,PropValue As Variant)
    Dim P As TProperty
    DefInt PProp = PropertyExists(hWnd&,PropName$)
    If PProp Then
       MemCpy P,PProp,SizeOf(P)
       Select Case VarType(PropValue)
       Case 0,1
            P.Value = PropValue
       Case 2
            PtrFree(P.Value)
            P.Value = NewZStr(PropValue)
       Case 3
            P.Value = PropValue
       End Select
       MemCpy PProp,P,SizeOf(P)
    End If
End Sub

Function GetPropValue(hWnd&,PropName$) As Variant
    Dim P As TProperty
    Dim V As Variant
    DefInt PProp = PropertyExists(hWnd&,PropName$)
    If PProp Then
       MemCpy P,PProp,SizeOf(P)
       Select Case P.Kind
       Case 0,1
            Result = P.Value
       Case 2
            Result = StrFromPtr(P.Value)
       Case 3
            If PtrSize(P.Value) > 12 Then
               DefInt Offset
               MemCpy VarPTR(Offset),P.Value,4
            End If
            'Result = StrFromPtr(Offset) 'display value "QFont" instead to ptr address
            Result = P.Value
       End Select
    End If
End Function

Function GetPropKind(hWnd&,PropName$) As Integer
    Dim P As TProperty
    DefInt PProp = PropertyExists(hWnd&,PropName$)
    If PProp Then
       MemCpy P,PProp,SizeOf(P)
       Result = P.Kind
    End If
End Function

Function GetPropAccess(hWnd&,PropName$) As Integer
    Dim P As TProperty
    DefInt PProp = PropertyExists(hWnd&,PropName$)
    If PProp Then
       MemCpy P,PProp,SizeOf(P)
       Result = P.Access
    End If
End Function

Function GetPropEditor(hWnd&,PropName$) As Integer
    Dim P As TProperty
    DefInt PProp = PropertyExists(hWnd&,PropName$)
    Result = -1
    If PProp Then
       MemCpy P,PProp,SizeOf(P)
       Result = P.Editor
    End If
End Function

Function GetPropLet(hWnd&,PropName$) As Integer
    Dim P As TProperty
    DefInt PProp = PropertyExists(hWnd&,PropName$)
    If PProp Then
       MemCpy P,PProp,SizeOf(P)
       Result = P.Let
    End If
End Function

Function GetPropGet(hWnd&,PropName$) As Integer
    Dim P As TProperty
    DefInt PProp = PropertyExists(hWnd&,PropName$)
    If PProp Then
       MemCpy P,PProp,SizeOf(P)
       Result = P.Get
    End If
End Function

Function GetPropList(hWnd&,PropList As QStringList,Access&) As Integer
    PropList.Clear
    Dim L As TList
    Dim P As TProperty
    Dim C As TControl
    DefInt i,PList,PCtrl = GetWindowLong(hWnd&,GetWndExtra(hWnd&,4))
    Result = 0
    If PCtrl Then
       MemCpy C,PCtrl,SizeOf(C)
       If C.PropList Then
          MemCpy L,C.PropList,SizeOf(L)
          ReDim Properties(L.Count) As Integer
          MemCpy VarPTR(Properties(0)),L.Items,SizeOf(Integer)*L.Count
          For i = 0 To L.Count -1
              MemCpy P,Properties(i),SizeOf(P)
              If P.Access = Access& Then
                 PropList.AddItems StrFromPtr(P.Name)-Chr$(0)
              End If
          Next i
          Result = PropList..ItemCount
       End If
    End If
    Result = PropList..ItemCount
End Function

Function FindClass(Class$) As Integer
    DefInt i
    DefStr s
    Dim Class As TClass
    Result = -1
    For i = 0 To UBound(ClassList) -1
        MemCpy Class,ClassList(i),SizeOf(Class)
        s = StrFromPtr(Class.ClassName) -Chr$(0)
        If UCase$(s) = UCase$(Class$) Then
           Result = i
           Exit For
        End If
    Next i
End Function

Function GetClassPropList(hWnd&) As Integer
    DefStr ClassName,s = Space$(255)
    DefInt i,L = GetClassName(hWnd&,s,255)
    ClassName = Left$(s,L)
    Dim Class As TClass
    Result = 0
    For i = 0 To UBound(ClassList) -1
        MemCpy Class,ClassList(i),SizeOf(Class)
        s = StrFromPtr(Class.ClassName)-Chr$(0)
        If UCase$(s) = UCase$(ClassName) Then
           Result = Class.PropList
           Exit For
        End If
    Next i
End Function

Function GetClassProc(hWnd&) As Integer
    DefStr ClassName,s = Space$(255)
    DefInt i,L = GetClassName(hWnd&,s,255)
    ClassName = Left$(s,L)
    Dim Class As TClass
    Result = 0
    For i = 0 To UBound(ClassList) -1
        MemCpy Class,ClassList(i),SizeOf(Class)
        s = StrFromPtr(Class.ClassName)-Chr$(0)
        If UCase$(s) = UCase$(ClassName) Then
           Result = Class.Proc
           Exit For
        End If
    Next i
End Function

Function GetClassExStyle(hWnd&) As Integer
    DefStr ClassName,s = Space$(255)
    DefInt i,L = GetClassName(hWnd&,s,255)
    ClassName = Left$(s,L)
    Dim Class As TClass
    Result = 0
    For i = 0 To UBound(ClassList) -1
        MemCpy Class,ClassList(i),SizeOf(Class)
        s = StrFromPtr(Class.ClassName)-Chr$(0)
        If UCase$(s) = UCase$(ClassName) Then
           Result = Class.ExStyle
           Exit For
        End If
    Next i
End Function

Function GetClassStyle(hWnd&) As Integer
    DefStr ClassName,s = Space$(255)
    DefInt i,L = GetClassName(hWnd&,s,255)
    ClassName = Left$(s,L)
    Dim Class As TClass
    Result = 0
    For i = 0 To UBound(ClassList) -1
        MemCpy Class,ClassList(i),SizeOf(Class)
        s = StrFromPtr(Class.ClassName)-Chr$(0)
        If UCase$(s) = UCase$(ClassName) Then
           Result = Class.Style
           Exit For
        End If
    Next i
End Function

Function GetClassCx(hWnd&) As Integer
    DefStr ClassName,s = Space$(255)
    DefInt i,L = GetClassName(hWnd&,s,255)
    ClassName = Left$(s,L)
    Dim Class As TClass
    Result = 0
    For i = 0 To UBound(ClassList) -1
        MemCpy Class,ClassList(i),SizeOf(Class)
        s = StrFromPtr(Class.ClassName)-Chr$(0)
        If UCase$(s) = UCase$(ClassName) Then
           Result = Class.Cx
           Exit For
        End If
    Next i
End Function

Function GetClassCy(hWnd&) As Integer
    DefStr ClassName,s = Space$(255)
    DefInt i,L = GetClassName(hWnd&,s,255)
    ClassName = Left$(s,L)
    Dim Class As TClass
    Result = 0
    For i = 0 To UBound(ClassList) -1
        MemCpy Class,ClassList(i),SizeOf(Class)
        s = StrFromPtr(Class.ClassName)-Chr$(0)
        If UCase$(s) = UCase$(ClassName) Then
           Result = Class.Cy
           Exit For
        End If
    Next i
End Function

Function GetClassPaintProc(hWnd&) As Integer
    DefStr ClassName,s = Space$(255)
    DefInt i,L = GetClassName(hWnd&,s,255)
    ClassName = Left$(s,L)
    Dim Class As TClass
    Result = 0
    For i = 0 To UBound(ClassList) -1
        MemCpy Class,ClassList(i),SizeOf(Class)
        s = StrFromPtr(Class.ClassName)-Chr$(0)
        If UCase$(s) = UCase$(ClassName) Then
           Result = Class.PaintProc
           Exit For
        End If
    Next i
End Function

Function GetClassAcceptCtrls(hWnd&) As Integer
    DefStr ClassName,s = Space$(255)
    DefInt i,L = GetClassName(hWnd&,s,255)
    ClassName = Left$(s,L)
    Dim Class As TClass
    Result = 0
    For i = 0 To UBound(ClassList) -1
        MemCpy Class,ClassList(i),SizeOf(Class)
        s = StrFromPtr(Class.ClassName)-Chr$(0)
        If UCase$(s) = UCase$(ClassName) Then
           Result = Class.AcceptCtrls
           Exit For
        End If
    Next i
End Function

Function GetClassBackColor(hWnd&) As Integer
    DefStr ClassName,s = Space$(255)
    DefInt i,L = GetClassName(hWnd&,s,255)
    ClassName = Left$(s,L)
    Dim Class As TClass
    Result = 0
    For i = 0 To UBound(ClassList) -1
        MemCpy Class,ClassList(i),SizeOf(Class)
        s = StrFromPtr(Class.ClassName)-Chr$(0)
        If UCase$(s) = UCase$(ClassName) Then
           Result = Class.BackColor
           Exit For
        End If
    Next i
End Function

Function GetClassAncestor(hWnd&) As String
    DefStr ClassName,s = Space$(255)
    DefInt i,L = GetClassName(hWnd&,s,255)
    ClassName = Left$(s,L)
    Dim Class As TClass
    Result = 0
    For i = 0 To UBound(ClassList) -1
        MemCpy Class,ClassList(i),SizeOf(Class)
        s = StrFromPtr(Class.ClassName)-Chr$(0)
        If UCase$(s) = UCase$(ClassName) Then
           Result = StrFromPtr(Class.Ancestor)-Chr$(0)
           Exit For
        End If
    Next i
End Function

'added 31.10.2008
Sub ChangeParent(hWnd&,NewParetWnd&)
    Dim Ctrl          As TControl
    Dim ParentCtrl    As TControl
    Dim NewParentCtrl As TControl
    Dim List          As TList
    DefInt i,Id,CtrlPtr,ParentPtr,NewParentPtr
    CtrlPtr = GetWindowLong(hWnd&,GetClassLong(hWnd&,GCL_CBWNDEXTRA)-4)
    If CtrlPtr Then
       MemCpy Ctrl,CtrlPtr,SizeOf(Ctrl)
       ParentPtr = Ctrl.Parent
       If ParentPtr Then
          MemCpy ParentCtrl,ParentPtr,SizeOf(ParentCtrl)
       End If
    End If
    NewParentPtr = GetWindowLong(NewParetWnd&,GetClassLong(NewParetWnd&,GCL_CBWNDEXTRA)-4)
    If NewParentPtr Then
       MemCpy NewParentCtrl,NewParentPtr,SizeOf(NewParentCtrl)
    End If
    If ParentPtr Then
       MemCpy ParentCtrl,ParentPtr,SizeOf(ParentCtrl)
       If ParentCtrl.Controls Then
          MemCpy List,ParentCtrl.Controls,SizeOf(List)
          If List.Items Then
             ReDim Controls(List.Count) As Integer
             MemCpy VarPTR(Controls(0)),List.Items,SizeOf(Integer)*List.Count
             For i = 0 To List.Count -1
                 If Controls(i) = CtrlPtr Then
                    Id = i
                    Exit For
                 End If
             Next i
             If Id <> -1 Then
                For i = Id +1 To List.Count -1
                    CtrlPtr = Controls(i)
                    Controls(i -1) = CtrlPtr
                Next i
                PtrFree(List.Items)
                List.Count = List.Count -1
                ReDim xControls(List.Count) As Integer
                MemCpy VarPTR(xControls(0)),VarPtr(Controls(0)),List.Count*SizeOf(Integer)
                List.Items = NewIntArray(List.Count)
                MemCpy List.Items,VarPTR(xControls(0)),SizeOf(Integer)*List.Count
                MemCpy ParentCtrl.Controls,List,SizeOf(List)
                MemCpy ParentPtr,ParentCtrl,SizeOf(ParentCtrl)
             End If
          End If
       End If
    End If
    If NewParentPtr Then
       Ctrl.Parent = NewParentPtr
       MemCpy NewParentCtrl,NewParentPtr,SizeOf(NewParentCtrl)
       If NewParentCtrl.Controls Then
          MemCpy List,NewParentCtrl.Controls,SizeOf(List)
          ReDim Controls(List.Count+1) As Integer
          MemCpy VarPTR(Controls(0)),List.Items,List.Count*SizeOf(Integer)
          PtrFree(List.Items)
          List.Count = List.Count +1
          List.Items = NewIntArray(List.Count)
          Controls(List.Count-1) = NewPtr(SizeOf(Ctrl),Ctrl)
          MemCpy List.Items,VarPTR(Controls(0)),List.Count*SizeOf(Integer)
          MemCpy NewParentCtrl.Controls,List,SizeOf(List)
          MemCpy NewParentPtr,NewParentCtrl,SizeOf(NewParentCtrl)
       Else
          Ctrl.Parent = NewParentPtr
          List.Count = 1
          List.Items = NewIntArray(List.Count)
          ReDim Controls(List.Count) As Integer
          Controls(List.Count-1) = CtrlPtr
          MemCpy List.Items,VarPTR(Controls(0)),SizeOf(Integer)*List.Count
          NewParentCtrl.Controls = NewPtr(SizeOf(List),List)'
          MemCpy NewParentPtr,ParentCtrl,SizeOf(NewParentCtrl)
       End If
    End If
End Sub

Function CopyPropFromClass(hWnd&) As Integer
    Dim List As TList
    Dim Prop As TProperty
    DefInt i,Ptr = GetClassPropList(hWnd&)
    Result = 0
    If Ptr Then
       MemCpy List,Ptr,SizeOf(List)
       ReDim Properties(List.Count) As Integer
       MemCpy VarPTR(Properties(0)),List.Items,List.Count*SizeOf(Integer)
       For i = 0 To List.Count -1
           MemCpy Prop,Properties(i),SizeOf(Prop)
           Properties(i) = NewPtr(SizeOf(Prop),Prop)
       Next i
       List.Items = NewIntArray(List.Count)
       MemCpy List.Items,VarPTR(Properties(0)),List.Count*SizeOf(Integer)
       Result = NewPtr(SizeOf(List),List)
    End If
End Function

Function AddControlToParent(hWnd&,BYREF Ctrl As TControl) As Integer
    Dim List As TList
    Dim Prop As TProperty
    Dim ParentCtrl As TControl
    DefInt ParentPtr,Parent = GetParent(hWnd&)
    Result = 0
    If Parent Then
       ParentPtr = GetWindowLong(Parent,GetWndExtra(Parent,4))
       If ParentPtr Then
          Ctrl.Parent = ParentPtr
          MemCpy ParentCtrl,ParentPtr,SizeOf(ParentCtrl)
          If ParentCtrl.Controls Then
             MemCpy List,ParentCtrl.Controls,SizeOf(List)
             ReDim Controls(List.Count+1) As Integer
             MemCpy VarPTR(Controls(0)),List.Items,List.Count*SizeOf(Integer)
             PtrFree(List.Items)
             List.Count = List.Count +1
             List.Items = NewIntArray(List.Count)
             Controls(List.Count-1) = NewPtr(SizeOf(Ctrl),Ctrl)
             MemCpy List.Items,VarPTR(Controls(0)),List.Count*SizeOf(Integer)
             MemCpy ParentCtrl.Controls,List,SizeOf(List)
             MemCpy ParentPtr,ParentCtrl,SizeOf(ParentCtrl)
          Else
             Ctrl.Parent = ParentPtr
             List.Count = 1
             List.Items = NewIntArray(List.Count)
             ReDim Controls(List.Count) As Integer
             Controls(List.Count-1) = NewPtr(SizeOf(Ctrl),Ctrl)
             MemCpy List.Items,VarPTR(Controls(0)),SizeOf(Integer)*List.Count
             ParentCtrl.Controls = NewPtr(SizeOf(List),List)'
             MemCpy ParentPtr,ParentCtrl,SizeOf(ParentCtrl)
          End If
       End If
       Result = Controls(List.Count-1)
    End If
End Function

Sub AddControlToOwner(hWnd&,CtrlPtr&)
    Dim List As TList
    Dim Prop As TProperty
    Dim OwnerCtrl As TControl
    DefInt OwnerPtr,Owner = GetAncestor(hWnd&,GA_ROOTOWNER)
    If Owner <> hWnd& Then
       OwnerPtr = GetWindowLong(Owner,GetWndExtra(Owner,8))
       If OwnerPtr Then
          MemCpy OwnerCtrl,OwnerPtr,SizeOf(OwnerCtrl)
          If OwnerCtrl.Controls Then
             MemCpy List,OwnerCtrl.Controls,SizeOf(List)
             ReDim Controls(List.Count+1) As Integer
             MemCpy VarPTR(Controls(0)),List.Items,SizeOf(Integer)*List.Count
             PtrFree(List.Items)
             List.Count = List.Count +1
             List.Items = NewIntArray(List.Count)
             Controls(List.Count-1) = CtrlPtr&
             MemCpy List.Items,VarPTR(Controls(0)),SizeOf(Integer)*List.Count
             MemCpy OwnerCtrl.Controls,List,SizeOf(List)
             MemCpy OwnerPtr,OwnerCtrl,SizeOf(OwnerCtrl)
          Else
             List.Count = 1
             List.Items = NewIntArray(List.Count)
             ReDim Controls(List.Count) As Integer
             Controls(List.Count-1) = CtrlPtr&
             MemCpy List.Items,VarPTR(Controls(0)),SizeOf(Integer)*List.Count
             OwnerCtrl.Controls = NewPtr(SizeOf(List),List)
             MemCpy OwnerPtr,OwnerCtrl,SizeOf(OwnerCtrl)
          End If
       End If
    Else
       SetWindowLong(hWnd&,GetWndExtra(Owner,8),NewPtr(SizeOf(OwnerCtrl),OwnerCtrl))
    End If
End Sub

Sub DeleteControlFromParentList(hWnd&)
    Dim List As TList
    Dim Prop As TProperty
    Dim ParentCtrl As TControl
    DefInt i,Id = -1,CtrlPtr
    DefInt Parent,ParentPtr
    Parent = GetParent(hWnd&)
    ParentPtr = GetWindowLong(Parent,GetWndExtra(Parent,4))
    CtrlPtr  = GetWindowLong(hWnd&,GetWndExtra(hWnd&,4))
    If ParentPtr Then
       MemCpy ParentCtrl,ParentPtr,SizeOf(ParentCtrl)
       If ParentCtrl.Controls Then
          MemCpy List,ParentCtrl.Controls,SizeOf(List)
          If List.Items Then
             ReDim Controls(List.Count) As Integer
             MemCpy VarPTR(Controls(0)),List.Items,SizeOf(Integer)*List.Count
             For i = 0 To List.Count -1
                 If Controls(i) = CtrlPtr Then
                    Id = i
                    Exit For
                 End If
             Next i
             If Id <> -1 Then
                For i = Id +1 To List.Count -1
                    CtrlPtr = Controls(i)
                    Controls(i -1) = CtrlPtr
                Next i
                PtrFree(List.Items)
                List.Count = List.Count -1
                ReDim xControls(List.Count) As Integer
                MemCpy VarPTR(xControls(0)),VarPtr(Controls(0)),List.Count*SizeOf(Integer)
                List.Items = NewIntArray(List.Count)
                MemCpy List.Items,VarPTR(xControls(0)),SizeOf(Integer)*List.Count
                MemCpy ParentCtrl.Controls,List,SizeOf(List)
                MemCpy ParentPtr,ParentCtrl,SizeOf(ParentCtrl)
             End If
          End If
       End If
    End If
End Sub

Sub DeleteControlFromOwnerList(hWnd&)
    Dim List As TList
    Dim Prop As TProperty
    Dim OwnerCtrl As TControl
    DefInt i,Id = -1,CtrlPtr
    DefInt OwnerPtr,Owner
    Owner = GetAncestor(hWnd&,GA_ROOTOWNER)
    OwnerPtr = GetWindowLong(Owner,GetWndExtra(Owner,8))
    CtrlPtr  = GetWindowLong(hWnd&,GetWndExtra(hWnd&,4))
    If OwnerPtr Then
       MemCpy OwnerCtrl,OwnerPtr,SizeOf(OwnerCtrl)
       If OwnerCtrl.Controls Then
          MemCpy List,OwnerCtrl.Controls,SizeOf(List)
          If List.Items Then
             ReDim Controls(List.Count) As Integer
             MemCpy VarPTR(Controls(0)),List.Items,SizeOf(Integer)*List.Count
             For i = 0 To List.Count -1
                 If Controls(i) = CtrlPtr Then
                    Id = i
                    Exit For
                 End If
             Next i
             If Id <> -1 Then
                PtrFree(List.Items)
                For i = Id +1 To List.Count -1
                    CtrlPtr = Controls(i)
                    Controls(i -1) = CtrlPtr
                Next i
                List.Count = List.Count -1
                ReDim xControls(List.Count) As Integer
                MemCpy VarPTR(xControls(0)),VarPtr(Controls(0)),List.Count*SizeOf(Integer)
                List.Items = NewIntArray(List.Count)
                MemCpy List.Items,VarPTR(xControls(0)),SizeOf(Integer)*List.Count
                MemCpy OwnerCtrl.Controls,List,SizeOf(List)
                MemCpy OwnerPtr,OwnerCtrl,SizeOf(OwnerCtrl)
             End If
          End If
       End If
    End If
End Sub

Sub RemovePointers(hWnd&)
    Dim Ctrl As TControl
    Dim List As TList
    DefInt i,CtrlPtr = GetWindowLong(hWnd&,GetWndExtra(hWnd&,4))
    If CtrlPtr Then
       MemCpy Ctrl,CtrlPtr,SizeOf(Ctrl)
       If Ctrl.PropList Then
          MemCpy List,Ctrl.PropList,SizeOf(List)
          PtrFree(List.Items)
       End If
       If Ctrl.Assigned Then
          MemCpy List,Ctrl.Assigned,SizeOf(List)
          PtrFree(List.Items)
       End If
       PtrFree(CtrlPtr)
    End If
End Sub

Function DefWndProc(hWnd&,Msg&,wParam&,lParam&) As Integer
    DefInt CtrlPtr,Child,Ptr,Color,Brush,PrevFont,FontPtr,PaintProcId = -1,Dc
    Dim Ctrl As TControl,List As TList
    Dim PS As PAINTSTRUCT
    Dim F  As TFont
    Dim R  As Rect
    Dim V  As Variant
    Select Case Msg&
    Case WM_CREATE
         Ctrl.Handle   = hWnd&
         Ctrl.Controls = NewPtr(SizeOf(List),List)
         Ctrl.Assigned = NewPtr(SizeOf(List),List)
         Ctrl.PropList = CopyPropFromClass(hWnd&)
         CtrlPtr = AddControlToParent(hWnd&,Ctrl)
         CtrlPtr = IIf(CtrlPtr,CtrlPtr,NewPtr(SizeOf(Ctrl),Ctrl))
         AddControlToOwner(hWnd&,CtrlPtr)
         SetWindowLong(hWnd&,GetWndExtra(hWnd&,4),CtrlPtr)
    Case WM_DESTROY
         DeleteControlFromParentList(hWnd&)
         DeleteControlFromOwnerList(hWnd&)
         RemovePointers(hWnd&)
    Case WM_CLOSE
         Result = 1
         Exit Function
    Case WM_PAINT
         FontPtr = GetPropValue(hWnd&,"Font")
         If FontPtr Then MemCpy F,FontPtr,SizeOf(F)
         PaintProcId  = GetClassPaintProc(hWnd&)
         Dc = BeginPaint(hWnd&,Ps)
         SelectObject(Dc,F.Handle)
         Brush = GetProp(hWnd&,"Brush")
         If Brush Then DeleteObject(Brush)
         Brush = CreateSolidBrush(GetPropValue(hWnd&,"Color"))
         R.Right  = Ps.rcpaint.Right
         R.Bottom = Ps.rcpaint.Bottom
         FillRect Dc,R,Brush
         SetTextColor(Dc,F.Color)
         If PaintProcId <> -1 Then
            CallFunc PaintProcs(PaintProcId),hWnd&,DC,Ps.rcpaint.Right,Ps.rcpaint.Bottom,GetPropValue(hWnd&,"Name")-Chr$(0)
         End If
         EndPaint(hWnd&,Ps)
    Case WM_CTLCOLORMSGBOX To WM_CTLCOLORSTATIC
         If Msg& = WM_CTLCOLORSTATIC Then
            If (GetWindowLong(lParam&,GWL_STYLE) AND SS_SIMPLE) = SS_SIMPLE Then
                Exit Function
            End If
         End If
         Child = lParam&
         If Child Then
            Brush = GetProp(Child,"Brush")
            If Brush Then DeleteObject(Brush)
            Brush = CreateSolidBrush(GetPropValue(Child,"Color"))
            DC = wParam&
            SetBKMode(DC,TRANSPARENT)
            Color = GetPropValue(Child,"Color")
            SetBKColor(DC,Color)
            Ptr = GetPropValue(Child,"Font")
            If Ptr Then
               MemCpy F,Ptr,SizeOf(F)
               SetTextColor(DC,F.Color)
            End If
            SetBKMode(DC,OPAQUE)
            Result = Brush
            Exit Function
         Else
            Child = hWnd&
            Brush = GetProp(Child,"Brush")
            If Brush Then DeleteObject(Brush)
            Brush = CreateSolidBrush(GetPropValue(Child,"Color"))
            DC = wParam&
            SetBKMode(DC,TRANSPARENT)
            Color = GetPropValue(Child,"Color")
            SetBKColor(DC,Color)
            Ptr = GetPropValue(Child,"Font")
            If Ptr Then
               MemCpy F,Ptr,SizeOf(F)
               SetTextColor(DC,F.Color)
            End If
            SetBKMode(DC,OPAQUE)
            Result = Brush
            Exit Function
         End If
    End Select
    Result = DefWindowProc(hWnd&,Msg&,wParam&,lParam&)
End Function

Function SuperWndProc(hWnd&,Msg&,wParam&,lParam&) As Integer
    DefInt CtrlPtr,Child,Ptr,Brush,Color,PrevFont,FontPtr,PaintProc,Dc
    Dim Ctrl As TControl,List As TList
    Dim PS As PAINTSTRUCT
    Dim F  As TFont
    Dim R  As Rect
    Dim V  As Variant
    Select Case Msg&
    Case WM_CREATE
         Ctrl.Handle   = hWnd&
         Ctrl.Controls = NewPtr(SizeOf(List),List)
         Ctrl.Assigned = NewPtr(SizeOf(List),List)
         Ctrl.PropList = CopyPropFromClass(hWnd&)
         CtrlPtr = AddControlToParent(hWnd&,Ctrl)
         CtrlPtr = IIf(CtrlPtr,CtrlPtr,NewPtr(SizeOf(Ctrl),Ctrl))
         AddControlToOwner(hWnd&,CtrlPtr)
         SetWindowLong(hWnd&,GetWndExtra(hWnd&,4),CtrlPtr)
    Case WM_DESTROY
         DeleteControlFromParentList(hWnd&)
         DeleteControlFromOwnerList(hWnd&)
         RemovePointers(hWnd&)
    Case WM_CTLCOLORMSGBOX To WM_CTLCOLORSTATIC
         If Msg& = WM_CTLCOLORSTATIC Then
            If (GetWindowLong(lParam&,GWL_STYLE) AND SS_SIMPLE) = SS_SIMPLE Then
                Exit Function
            End If
         End If
         Child = lParam&
         If Child Then
            Brush = GetProp(Child,"Brush")
            If Brush Then DeleteObject(Brush)
            Brush = CreateSolidBrush(GetPropValue(Child,"Color"))
            DC = wParam&
            SetBKMode(DC,TRANSPARENT)
            Color = GetPropValue(Child,"Color")
            SetBKColor(DC,Color)
            Ptr = GetPropValue(Child,"Font")
            If Ptr Then
               MemCpy F,Ptr,SizeOf(F)
               SetTextColor(DC,F.Color)
            End If
            SetBKMode(DC,OPAQUE)
            Result = Brush
            Exit Function
         Else
            Child = hWnd&
            Brush = GetProp(Child,"Brush")
            If Brush Then DeleteObject(Brush)
            Brush = CreateSolidBrush(GetPropValue(Child,"Color"))
            DC = wParam&
            SetBKMode(DC,TRANSPARENT)
            Color = GetPropValue(Child,"Color")
            SetBKColor(DC,Color)
            Ptr = GetPropValue(Child,"Font")
            If Ptr Then
               MemCpy F,Ptr,SizeOf(F)
               SetTextColor(DC,F.Color)
            End If
            SetBKMode(DC,OPAQUE)
            Result = Brush
            Exit Function
         End If
    End Select
    Result = CallWindowProc(GetClassProc(hWnd&),hWnd&,Msg&,wParam&,lParam&)
End Function

Sub RegisterControlClass(Class$,Ancestor$,ExStyle&,Style&,cx&,cy&,BackColor&,AcceptControls&,PaintProc&,ClassStyle&)
    DefInt PrevProc
    Dim Wc As WNDCLASS
    Dim Class As TClass
    If Ancestor$ <> "" Then
       If GetClassInfo(0,Ancestor$,Wc) <> 0 Then
          PrevProc = Wc.lpfnWndProc
          Wc.lpszClassName = NewZStr(Class$)
          Wc.lpfnWndProc   = SuperProc
          Wc.hInstance     = GetModuleHandle(0)
          Wc.cbWndExtra    = Wc.cbWndExtra +8
          If RegisterClass(Wc) Then
             Class.ClassName   = NewZStr(Class$)
             Class.Ancestor    = NewZStr(Ancestor$)
             Class.Proc        = PrevProc
             Class.ExStyle     = ExStyle&
             Class.Style       = Style&
             Class.Cx          = Cx&
             Class.Cy          = Cy&
             Class.BackColor   = BackColor&
             Class.AcceptCtrls = AcceptControls&
             Class.PaintProc   = PaintProc&
             ReDim ClassList(UBound(ClassList)+1) As Integer
             ClassList(UBound(ClassList)-1) = NewPtr(SizeOf(Class),Class)
          End If
       End If
    Else
       Wc.style         = ClassStyle&
       Wc.lpszClassName = NewZStr(Class$)
       Wc.lpfnWndProc   = DefProc
       Wc.hInstance     = GetModuleHandle(0)
       Wc.hbrBackground = CreateSolidBrush(BackColor&)
       Wc.hCursor       = LoadCursor(0,IDC_ARROW)
       Wc.cbWndExtra    = 8
       Wc.lpszMenuName  = 0
       Wc.hIcon         = 0
       If RegisterClass(Wc) Then
          Class.ClassName   = NewZStr(Class$)
          Class.Ancestor    = NewZStr(Ancestor$)
          Class.Proc        = PrevProc
          Class.ExStyle     = ExStyle&
          Class.Style       = Style&
          Class.Cx          = Cx&
          Class.Cy          = Cy&
          Class.BackColor   = BackColor&
          Class.AcceptCtrls = AcceptControls&
          Class.PaintProc   = PaintProc&
          ReDim ClassList(UBound(ClassList)+1) As Integer
          ClassList(UBound(ClassList)-1) = NewPtr(SizeOf(Class),Class)
       End If
    End If
End Sub

Sub AddClassProperty(Class$,PropName$,PropValue$,PropKind&,Access&,Editor&)
    Dim L     As TList
    Dim P     As TProperty
    Dim Class As TClass
    DefInt i,Ptr,Properties()
    i = FindClass(Class$)
    If i <> -1 Then
       MemCpy Class,ClassList(i),SizeOf(Class)
       Ptr = Class.PropList
       If Ptr = 0 Then
          L.Count = 1
          L.Items = NewIntArray(1)
          ReDim Properties(1) As Integer
          P.Name   = NewZStr(PropName$)
          P.Value  = Val(PropValue$)
          P.Kind   = PropKind&
          P.Access = Access&
          P.Editor = Editor&
          Properties(0) = NewPtr(SizeOf(P),P)
          MemCpy L.Items,VarPTR(Properties(0)),SizeOf(Integer)
          Ptr = NewPtr(SizeOf(L),L)
          Class.PropList = Ptr
          MemCpy ClassList(i),Class,SizeOf(Class)
       Else
          MemCpy L,Ptr,SizeOf(L)
          ReDim Properties(L.Count +1) As Integer
          MemCpy VarPTR(Properties(0)),L.Items,L.Count*SizeOf(Integer)
          PtrFree(L.Items)
          P.Name   = NewZStr(PropName$)
          P.Value  = Val(PropValue$)
          P.Kind   = PropKind&
          P.Access = Access&
          P.Editor = Editor&
          Properties(L.Count) = NewPtr(SizeOf(P),P)
          L.Count = L.Count +1
          L.Items = NewIntArray(L.Count)
          MemCpy L.Items,VarPTR(Properties(0)),L.Count*SizeOf(Integer)
          MemCpy Ptr,L,SizeOf(L)
          MemCpy ClassList(i),Class,SizeOf(Class)
       End If
    End If
End Sub

Sub AddStandardProperties
    DefInt i
    DefStr s
    Dim Class As TClass
    For i = 0 To UBound(ClassList) -1
        MemCpy Class,ClassList(i),SizeOf(Class)
        s = StrFromPtr(Class.ClassName)-Chr$(0)
        AddClassProperty(s,"Left","0",0,1,-1)
        AddClassProperty(s,"Top","0",0,1,-1)
        AddClassProperty(s,"Width","0",0,1,-1)
        AddClassProperty(s,"Height","0",0,1,-1)
        AddClassProperty(s,"ClientWidth","0",0,0,-1)
        AddClassProperty(s,"ClientHeight","0",0,0,-1)
        AddClassProperty(s,"Text","",2,1,-1)
        AddClassProperty(s,"Name","",2,1,-1)
        AddClassProperty(s,"Font","",3,1,-1)
        AddClassProperty(s,"Color","",0,1,-1)
        AddClassProperty(s,"Cursor","",0,1,-1)
        AddClassProperty(s,"AccepControls","",0,0,-1)
    Next i
    RegisterPropertyLetHandler("","Left",1)
    RegisterPropertyLetHandler("","Top",1)
    RegisterPropertyLetHandler("","Width",1)
    RegisterPropertyLetHandler("","Height",1)
    RegisterPropertyLetHandler("","Text",2)
End Sub

Sub RegisterClasses
    DefInt F4
    Bind F4 To DefWndProc
    DefProc = SetNewCallback_4(F4)
    Bind F4 To SuperWndProc
    SuperProc = SetNewCallback_4(F4)
    DefInt ColorBtnFace = GetSysColor(COLOR_BTNFACE)
    DefInt ColorWindow  = GetSysColor(COLOR_WINDOW)
    RegisterControlClass("QForm","",0,ws_overlappedwindow,300,250,ColorBtnFace,1,-1,0)
    RegisterControlClass("QPanel","",0,ws_border,221,55,ColorBtnFace,1,-1,0)
    RegisterControlClass("QLabel","Static",0,0,97,13,ColorBtnFace,0,-1,0)
    RegisterControlClass("QButton","Button",0,bs_pushbutton,75,35,ColorBtnFace,0,-1,0)
    RegisterControlClass("QEdit","Edit",ws_ex_clientedge,es_nohidesel,121,21,ColorWindow,0,0,0)
    RegisterControlClass("QComboBox","ComboBox",0,cbs_hasstrings or cbs_dropdownlist,121,21,ColorWindow,0,-1,0)
    RegisterControlClass("QGroupBox","",0,0,121,55,ColorBtnFace,0,1,cs_hredraw or cs_vredraw)
    AddStandardProperties
End Sub

Sub UnRegisterClasses
    DefInt i
    Dim Class As TClass
    For i = 0 To UBound(ClassList)-1
        MemCpy Class,ClassList(i),SizeOf(Class)
        UnregisterClass StrFromPtr(Class.ClassName),GetModuleHandle(0)
        PtrFree(ClassList(i))
    Next i
End Sub


Declare Sub TFormDesigner.CreateControl(Control&,Name$)
Declare Sub TFormDesigner.InsertControl(Control&)
Declare Sub TFormDesigner.DeletingControl(Control&)
Declare Sub TFormDesigner.ChangeSelection(Control&)
Declare Sub TFormDesigner.Modified(Form&)
Declare Sub TFormDesigner.DesignFormMouseMove(x&,y&,Shift&)
Declare Sub TFormDesigner.DesignFormActivate()
Declare Sub TFormDesigner.DesignFormMove(Form&,x&,y&)
Declare Sub TFormDesigner.DesignFormSize(Form&,cx&,cy&)
Declare Sub TFormDesigner.DesignFormKeyDown(Key&,Shift&)
Declare Sub TFormDesigner.DesignFormShow(Form&)
Declare Sub TFormDesigner.DesignFormHide(Form&)
Declare Sub TFormDesigner.DesignFormClose(BYREF Action As Integer)
Type TFormDesigner Extends QObject
    Private:
    Procs         As QStringList
    Names         As QStringList
    DotIndex      As Integer
    Dots(8)       As Integer
    EnumChildProc As Integer
    FormProc      As Integer
    ControlProc   As Integer
    DotProc       As Integer
    DotBrush      As Integer
    cr_Arrow      As Integer
    cr_HandPoint  As Integer
    cr_Cross      As Integer
    cr_Size       As Integer
    cr_SizeNESW   As Integer
    cr_SizeNS     As Integer
    cr_SizeNWSE   As Integer
    cr_SizeWE     As Integer
    CanInsert     As Integer
    CanMove       As Integer
    CanSize       As Integer
    Down          As Integer
    BeginX        As Integer
    BeginY        As Integer
    EndX          As Integer
    EndY          As Integer
    NewX          As Integer
    NewY          As Integer
    Left          As Integer
    Top           As Integer
    Width         As Integer
    Height        As Integer
    OverControl   As Integer
    SizeControl   As Integer
    Public:
    FormCount         As Integer
    FormList()        As Integer
    SnapToGrid        As Integer
    ClassName         As String
    GridX             As Integer Property Set SetGridX
    GridY             As Integer Property Set SetGridY
    GridColor         As Integer Property Set SetGridColor
    DotColor          As Integer Property Set SetDotColor
    SelControl        As Integer Property Set SetSelControl
    DesignForm        As Integer Property Set SetDesignForm
    ShowGrid          As Integer Property Set SetShowGrid
    DesignFormVisible As Integer Property Set SetDesignFormVisible

    '''Events
    OnCreateControl   As Event(TFormDesigner.CreateControl)
    OnInsertControl   As Event(TFormDesigner.InsertControl)
    OnDeletingControl As Event(TFormDesigner.DeletingControl)
    OnChangeSelection As Event(TFormDesigner.ChangeSelection)
    OnModified        As Event(TFormDesigner.Modified)

    OnDesignFormMouseMove As Event(TFormDesigner.DesignFormMouseMove)
    OnDesignFormActivate  As Event(TFormDesigner.DesignFormActivate)
    OnDesignFormMove      As Event(TFormDesigner.DesignFormMove)
    OnDesignFormSize      As Event(TFormDesigner.DesignFormSize)
    OnDesignFormKeyDown   As Event(TFormDesigner.DesignFormKeyDown)
    OnDesignFormShow      As Event(TFormDesigner.DesignFormShow)
    OnDesignFormHide      As Event(TFormDesigner.DesignFormHide)
    OnDesignFormKeyClose  As Event(TFormDesigner.DesignFormClose)

    With This

    Public:

    Function GetName(ClassName$) As String
        DefInt i,ID
        DefStr s
        For i = 0 To .Names.ItemCount-1
        s = .Names.Item(i)
        If UCase$(Field$(s,",",1)) = UCase$(ClassName$) Then
           ID = Val(Field$(s,",",2))
           ID++
           .Names.Item(i) = Format$("%s,%d",ClassName$,ID)
           Result = Mid$(ClassName$,2,Len(ClassName$)) + Str$(ID)
           Exit Function
        End If
        Next i
        .Names.AddItems Format$("%s,1",ClassName$)
        Result = Mid$(ClassName$,2,Len(ClassName$)) + "1"
    End Function
    
    Function GetClassMember(ClassName$,mType&) As Variant
        DefInt i
        DefStr s
        Dim Class As TClass
        For i = 0 To UBound(ClassList) -1
            MemCpy Class,ClassList(i),SizeOf(Class)
            s = StrFromPtr(Class.ClassName)-Chr$(0)
            If UCase$(s) = UCase$(ClassName$) Then
               Select Case mType&
               Case clsClassName
                Result = StrFromPtr(Class.ClassName)
               Case clsAncestor
                Result = StrFromPtr(Class.Ancestor)
               Case clsProc
                Result = Class.Proc
               Case clsExStyle
                Result = Class.ExStyle
               Case clsStyle
                Result = Class.Style
               Case clsCx
                Result = Class.Cx
               Case clsCy
                Result = Class.Cy
               Case clsAcceptCtrls
                Result = Class.AcceptCtrls
               Case clsPaintProc
                Result = Class.PaintProc
               Case clsPropList
                Result = Class.PropList
               End Select
           End If
        Next i
    End Function

    Function GetClassExStyle(ClassName$) As Integer
        Result = .GetClassMember(ClassName$,clsExStyle)
    End Function

    Function GetClassStyle(ClassName$) As Integer
         Result = .GetClassMember(ClassName$,clsStyle)
    End Function

    Function GetClassCx(ClassName$) As Integer
         Result = .GetClassMember(ClassName$,clsCx)
    End Function

    Function GetClassCy(ClassName$) As Integer
         Result = .GetClassMember(ClassName$,clsCy)
    End Function

    Function GetClassAcceptControls(ClassName$) As Integer
         Result = .GetClassMember(ClassName$,clsAcceptCtrls)
    End Function

    Function GetClassName(hWnd&) As String
         DefStr Cn = Space$(255)
         DefInt L = GetClassName(hWnd&,Cn,255)
         Result = Left$(Cn,L)
     End Function

    Sub SubClassForm(hWnd&)
        DefInt Proc = SetWindowLong(hWnd&,GWL_WNDPROC,.FormProc)
        .Procs.AddItems Format$("%d,%d",hWnd&,Proc)
    End Sub

    Sub CreateForm(ClassName As String,Caption As String,Name As String,Parent As Integer,x As Integer,y As Integer,cx As Integer,cy As Integer)
        Name = IIf(Name <> "",Name,.GetName(ClassName))
        .DesignForm = CreateWindowEx(.GetClassExStyle(ClassName),_
                                     ClassName,_
                                     IIf(Caption <> "",Caption,Name),_
                                     WS_CLIPSIBLINGS Or WS_CLIPCHILDREN Or .GetClassStyle(ClassName),_
                                     x,_
                                     y,_
                                     IIf(cx,cx,.GetClassCx(ClassName)),_
                                     IIf(cy,cy,.GetClassCy(ClassName)),_
                                     Parent,_
                                     0,_
                                     GetModuleHandle(0),_
                                     0)
        If .DesignForm Then
           Dim V As Variant
           Dim F As TFont
           V = FontCreate("Tahoma",8,0,0,0,0,DEFAULT_CHARSET)
           SetPropValue(.DesignForm,"Font",v)
           MemCpy F,V,SizeOf(F)
           SendMessage(.DesignForm,WM_SETFONT,F.Handle,1)
           v = GetClassBackColor(.DesignForm)
           SetPropValue(.DesignForm,"Color",v)
           .SubClassForm .DesignForm
           SetWindowText .DesignForm,Name
           .FormCount++
           ReDim .FormList(.FormCount) As Integer
           .FormList(.FormCount -1) = .DesignForm
           If .OnCreateControl Then CallFunc .OnCreateControl,.DesignForm,Name
        End If
    End Sub

    Sub SubClassControl(hWnd&)
        DefInt Proc = SetWindowLong(hWnd&,GWL_WNDPROC,.ControlProc)
        .Procs.AddItems Format$("%d,%d",hWnd&,Proc)
    End Sub

    Sub CreateControl(ClassName As String,Caption As String,Name As String,Parent As Integer,x As Integer,y As Integer,cx As Integer,cy As Integer)
        Name = IIf(Name <> "",Name,.GetName(ClassName))
        .SelControl = CreateWindowEx(.GetClassExStyle(ClassName),_
                                     ClassName,_
                                     IIf(Caption <> "",Caption,Name),_
                                     WS_CHILD Or WS_CLIPSIBLINGS Or WS_CLIPCHILDREN Or .GetClassStyle(ClassName),_
                                     x,_
                                     y,_
                                     IIf(cx,cx,.GetClassCx(ClassName)),_
                                     IIf(cy,cy,.GetClassCy(ClassName)),_
                                     Parent,_
                                     0,_
                                     GetModuleHandle(0),_
                                     0)
        If .SelControl Then
           Dim V As Variant
           Dim F As TFont
           V = FontCreate("Tahoma",8,0,0,0,0,DEFAULT_CHARSET)
           SetPropValue(.SelControl,"Font",v)
           MemCpy F,V,SizeOf(F)
           SendMessage(.SelControl,WM_SETFONT,F.Handle,1)
           v = GetClassBackColor(.SelControl)
           SetPropValue(.SelControl,"Color",v)
           .SubClassControl .SelControl
           SetWindowText .SelControl,Name
           If .OnCreateControl Then CallFunc .OnCreateControl,.SelControl,Name
           ShowWindow .SelControl,SW_SHOW
        End If
    End Sub

    Private:

    Sub DrawBox(x&,y&,cx&,cy&)
        DefInt Dc = GetDCEx(.DesignForm,0,DCX_PARENTCLIP Or DCX_CACHE)
        DefInt Brush = GetStockObject(NULL_BRUSH)
        DefInt PrevBrush = SelectObject(Dc,Brush)
        SetROP2(Dc,R2_NOT)
        Rectangle(Dc,x&,y&,cx&,cy&)
        SelectObject(Dc,PrevBrush)
        ReleaseDc(.DesignForm,Dc)
    End Sub

    Sub MoveDots(Control&)
       Dim R As Rect
       Dim P As Point
       DefInt i,W,H
       GetWindowRect Control&,R
       W = R.Right  - R.Left
       H = R.Bottom - R.Top
       P.x = R.Left
       P.y = R.Top
       ScreenToClient GetParent(Control&),P
       For i = 0 To 7
          SetParent .Dots(i),GetParent(Control&)
          SetProp .Dots(i),"Control",Control&
       Next i
       SetWindowPos(.Dots(0),HWND_TOP,P.X-3,P.Y-3,0,0,SWP_NOSIZE OR SWP_SHOWWINDOW)
       SetWindowPos(.Dots(1),HWND_TOP,P.X + W/2-3,P.Y-3,0,0,SWP_NOSIZE OR SWP_SHOWWINDOW)
       SetWindowPos(.Dots(2),HWND_TOP,P.X + W-3,P.Y-3,0,0,SWP_NOSIZE OR SWP_SHOWWINDOW)
       SetWindowPos(.Dots(3),HWND_TOP,P.X + W-3,P.Y + H/2-3,0,0,SWP_NOSIZE OR SWP_SHOWWINDOW)
       SetWindowPos(.Dots(4),HWND_TOP,P.X + W-3,P.Y + H-3,0,0,SWP_NOSIZE OR SWP_SHOWWINDOW)
       SetWindowPos(.Dots(5),HWND_TOP,P.X + W/2-3,P.Y + H-3,0,0,SWP_NOSIZE OR SWP_SHOWWINDOW)
       SetWindowPos(.Dots(6),HWND_TOP,P.X-3,P.Y + H-3,0,0,SWP_NOSIZE OR SWP_SHOWWINDOW)
       SetWindowPos(.Dots(7),HWND_TOP,P.X-3,P.Y + H/2-3,0,0,SWP_NOSIZE OR SWP_SHOWWINDOW)
    End Sub

    Sub HideDots
         DefInt i
         For i = 0 To 7
            ShowWindow .Dots(i),SW_HIDE
         Next i
    End Sub

    Function IsDot(hWnd&) As Integer
       Result = -1
       DefStr Cn = Space$(255),s
       DefInt i,L = GetClassName(hWnd&,Cn,255)
       s = Left$(Cn,L)
       If s = "QDot" Then
          For i = 0 To 7
              If .Dots(i) = hWnd& Then
                 Result = i
                 Exit For
              End If
          Next i
       End If
    End Function
    
    Function ControlAt(X As Integer,Y As Integer) As Integer
       DefInt i,PList,PtrCtrl
       Dim List As TList
       Dim Ctrl As TControl
       Dim R As Rect
       Result = .DesignForm
       PtrCtrl = GetWindowLong(.DesignForm,GetWndExtra(.DesignForm,8))
       If PtrCtrl Then
          MemCpy Ctrl,PtrCtrl,SizeOf(Ctrl)
          If Ctrl.Controls Then
             MemCpy List,Ctrl.Controls,SizeOf(List)
             ReDim Controls(List.Count) As Integer
             MemCpy VarPTR(Controls(0)),List.Items,SizeOf(Integer)*List.Count
             For i = List.Count -1 To 0 Step -1
                 MemCpy Ctrl,Controls(i),SizeOf(Ctrl)
                 GetWindowRect Ctrl.Handle,R
                 MapWindowPoints 0,.DesignForm,R,2
                 If (X > R.Left And X < R.Right) And (Y > R.Top And Y < R.Bottom) Then
                    Result = Ctrl.Handle
                    Exit For
                 End If
             Next i
          End If
        End If
    End Function

    Sub MouseDown(hWnd&,bButton&,x&,y&,Shift&)
        Dim R As Rect
        Dim P As Point
        If .SnapToGrid Then
           .BeginX = (X&\.GridX)*.GridX
           .BeginY = (Y&\.GridY)*.GridY
        Else
           .BeginX = X&
           .BeginY = Y&
        End If
        .EndX = .BeginX
        .EndY = .BeginY
        .NewX = .BeginX
        .NewY = .BeginY
        .Down = 1
        .SelControl = .ControlAt(X&,Y&)
        .DotIndex   = .IsDot(.OverControl)
        If .DotIndex <> -1 Then
           .CanInsert = 0
           .CanMove   = 0
           .CanSize   = 1
           .SizeControl = GetProp(.Dots(.DotIndex),"Control")
           .SelControl  = .SizeControl
           .HideDots
           GetWindowRect .SizeControl,R
           P.x = R.Left
           P.y = R.Top
           .Width  = R.Right - R.Left
           .Height = R.Bottom - R.Top
           ScreenToClient GetParent(.SizeControl),P  '
           .Left = P.X
           .Top  = P.Y '
           Select Case .DotIndex
           Case 0
                SetCursor .cr_SizeNWSE
           Case 1
                SetCursor .cr_SizeNS
           Case 2
                SetCursor .cr_SizeNESW
           Case 3
                SetCursor .cr_SizeWE
           Case 4
                SetCursor .cr_SizeNWSE
           Case 5
                SetCursor .cr_SizeNS
           Case 6
                SetCursor .cr_SizeNESW
           Case 7
                SetCursor .cr_SizeWE
           End Select
        Else
           If .SelControl <> .DesignForm Then
              If .ClassName <> "" Then
                 .CanInsert = 1
                 .CanMove   = 0
                 .CanSize   = 0
                 SetCursor .cr_Cross
              Else
                 .CanInsert = 0
                 .CanMove   = 1
                 .CanSize   = 0
                 SetCursor .cr_HandPoint
                 If .OnChangeSelection Then CallFunc .OnChangeSelection,.SelControl
                 GetWindowRect .SelControl,R
                 P.x = R.Left
                 P.y = R.Top
                 .Width  = R.Right - R.Left
                 .Height = R.Bottom - R.Top
                 ScreenToClient GetParent(.SelControl),P  '
                 .Left = P.X
                 .Top  = P.Y
              End If
           Else
              .HideDots
              .CanInsert = IIf(.ClassName <> "",1,0)
              .CanMove   = 0
              .CanSize   = 0
              If .CanInsert Then
                 SetCursor .cr_Cross
              Else
                 If .OnChangeSelection Then CallFunc .OnChangeSelection,.SelControl
              End If
           End If
           'If .CanInsert Or .CanMove Or .CanSize Then
              'If .GetClassAcceptControls(.GetClassName(.SelControl)) Then
              '   GetClientRect(.SelControl,R)
              '   MapWindowPoints(.SelControl,0,R,2)
              'ElseIf .GetClassAcceptControls(.GetClassName(GetParent(.SelControl))) Then
              '   GetClientRect(GetParent(.SelControl),R)
              '   MapWindowPoints(GetParent(.SelControl),0,R,2)
              'Else
              '   GetClientRect(.DesignForm,R)
              '   MapWindowPoints(.DesignForm,0,R,2)
              'End If
              'ClipCursor(R)
           'End If
        End If
    End Sub

    Sub MouseMove(hWnd&,x&,y&,Shift&)
        Dim R As Rect
        Dim P As Point
        GetClientRect .DesignForm, R
        If (X& < R.Left Or X& > R.Right) Or _
           (Y& < R.Top  Or Y& > R.Bottom) Then
           ReleaseCapture
           Exit Sub
        Else
           SetCapture hWnd&
        End If
        If .SnapToGrid Then
           .NewX = (X&\.GridX)*.GridX
           .NewY = (Y&\.GridY)*.GridY
        Else
           .NewX = X&
           .NewY = Y&
        End If
        If .Down Then
           GetClientRect(.DesignForm,R)
           MapWindowPoints(.DesignForm,0,R,2)
           ClipCursor(R)
           
           If .CanInsert Then
              SetCursor .cr_Cross
              .DrawBox .BeginX,.BeginY,.NewX,.NewY
              .DrawBox .BeginX,.BeginY,.EndX,.EndY
           End If
           If .CanSize Then
              Select Case .DotIndex
              Case 1
                   MoveWindow .SizeControl,.Left,.Top + (.NewY - .BeginY),.Width ,.Height - (.NewY - .BeginY),1
              Case 2
                   MoveWindow .SizeControl,.Left,.Top + (.NewY - .BeginY),.Width + (.NewX - .BeginX) ,.Height - (.NewY - .BeginY),1
              Case 3
                   MoveWindow .SizeControl,.Left,.Top,.Width + (.NewX - .BeginX),.Height,1
              Case 4
                   MoveWindow .SizeControl,.Left,.Top,.Width + (.NewX - .BeginX),.Height + (.NewY - .BeginY),1
              Case 5
                   MoveWindow .SizeControl,.Left,.Top,.Width ,.Height + (.NewY - .BeginY),1
              Case 6
                   MoveWindow .SizeControl,.Left + (.NewX - .BeginX),.Top,.Width - (.NewX - .BeginX) ,.Height + (.NewY - .BeginY),1
              Case 7
                   MoveWindow .SizeControl,.Left - (.BeginX - .NewX) ,.Top,.Width + (.BeginX - .NewX),.Height,1
              End Select
           End If
           If .CanMove Then
              If .BeginX <> .EndX Or .BeginY <> .EndY Then
                 .HideDots
                 MoveWindow .SelControl,.Left + (.NewX - .BeginX),.Top + (.NewY - .BeginY),.Width,.Height,1
              End If
           End If
        Else
           GetCursorPos P
           .OverControl = WindowFromPoint(P.x,P.y)
           DefInt Id = .IsDot(.OverControl)
           If Id <> -1 Then
              Select Case Id
              Case 0
                   SetCursor .cr_SizeNWSE
              Case 1
                   SetCursor .cr_SizeNS
              Case 2
                   SetCursor .cr_SizeNESW
              Case 3
                   SetCursor .cr_SizeWE
              Case 4
                   SetCursor .cr_SizeNWSE
              Case 5
                   SetCursor .cr_SizeNS
              Case 6
                   SetCursor .cr_SizeNESW
              Case 7
                   SetCursor .cr_SizeWE
              End Select
           Else
              SetCursor .cr_Arrow
              ClipCursor(0)
           End If
        End If
        .EndX = .NewX
        .EndY = .NewY
        If .OnDesignFormMouseMove Then CallFunc .OnDesignFormMouseMove, x&,y&,Shift&
    End Sub

    Sub MouseUp(hWnd&,bButton&,x&,y&,Shift&)
        Dim R As Rect
        DefInt TempX = 0,TempY = 0
        If .Down Then
           .Down = 0
           If .CanInsert Then
              If (.BeginX > .EndX And .BeginY > .EndY) Then
                 TempX   = .BeginX
                 .BeginX = .NewX
                 .NewX   = TempX
                 TempY   = .BeginY
                 .BeginY = .NewY
                 .NewY   = TempY
              End If
              If (.BeginX > .EndX And .BeginY < .EndY) Then
                 TempX   = .BeginX
                 .BeginX = .NewX
                 .NewX   = TempX
              End If
              If (.BeginX < .EndX And .BeginY > .EndY) Then
                 TempY   = .BeginY
                 .BeginY = .NewY
                 .NewY   = TempY
              End If
              .DrawBox .BeginX,.BeginY,.NewX,.NewY
              If .GetClassAcceptControls(.GetClassName(.SelControl)) Then
                 R.Left   = .BeginX
                 R.Top    = .BeginY
                 R.Right  = .NewX
                 R.Bottom = .NewY
                 MapWindowPoints .DesignForm,.SelControl,R,2
                 .CreateControl(.ClassName,"","",.SelControl,R.Left,R.Top,R.Right -R.Left,R.Bottom -R.Top)
              Else
                 .CreateControl(.ClassName,"","",.DesignForm,.BeginX,.BeginY,.NewX -.BeginX,.NewY -.BeginY)
              End If
              If .SelControl Then
                 BringWindowToTop .SelControl
                 .MoveDots .SelControl
                 If .OnInsertControl Then CallFunc .OnInsertControl,.SelControl
              End If
              .CanInsert = 0
           End If
           If .CanSize Then
              .MoveDots .SizeControl
              .CanSize = 0
              If .OnModified Then CallFunc .OnModified, .DesignForm
           End If
           If .CanMove Then
              .MoveDots .SelControl
              .CanMove = 0
              If .OnModified Then CallFunc .OnModified ,.DesignForm
           End If
           ClipCursor(0)
           .BeginX = .EndX
           .BeginY = .EndY
           .NewX = .BeginX
           .NewY = .BeginY
        End If
    End Sub

    Sub FormKeyDown(hWnd&,Key&,Shift&)
        If Key& = VK_DELETE Then
           If .SelControl Then
              If .SelControl <> .DesignForm Then
                 If .OnDeletingControl Then CallFunc .OnDeletingControl,.SelControl
                 DestroyWindow .SelControl
                 If .OnModified Then CallFunc .OnModified ,.DesignForm
                 .HideDots
                 .SelControl = .DesignForm
                 If .OnChangeSelection Then CallFunc .OnChangeSelection,.SelControl
              End If
           End If
        End If
        If .OnDesignFormKeyDown Then CallFunc .OnDesignFormKeyDown, Key&,Shift&
    End Sub

    Sub Activate(hWnd&)
        .DesignForm = hWnd&
        .HideDots
        If .OnDesignFormActivate Then CallFunc .OnDesignFormActivate
    End Sub

    Sub DeActivate(hWnd&)
        ReleaseCapture
    End Sub

    Function GetProc(hWnd&) As Integer
        DefInt i
        Result = GetWindowLong(hWnd&,GWL_WNDPROC)
        For i = 0 To .Procs.ItemCount -1
            If Val(Field$(.Procs.Item(i),",",1)) = hWnd& Then
               Result = Val(Field$(.Procs.Item(i),",",2))
               Exit For
            End If
        Next i
    End Function

    Function FormWndProc(hWnd&,Msg&,wParam&,lParam&) As Integer
        Dim V  As Variant
        Dim WP As WINDOWPOS
        Result = CallWindowProc(.GetProc(hWnd&),hWnd&,Msg&,wParam&,lParam&)
        Select Case Msg&
        Case WM_PAINT
             DefInt Dc = GetDC(hWnd&)
             DrawGrid(Dc,.GridX,.GridY,.GridColor)
             ReleaseDc(hWnd&,Dc)
        Case WM_LBUTTONDOWN
             SetActiveWindow(hWnd&)
             .MouseDown(hWnd&,0,LoWord(lParam&),HiWord(lParam&),wParam& And &HFFFF)
        Case WM_LBUTTONUP
             .MouseUp(hWnd&,0,LoWord(lParam&),HiWord(lParam&),wParam& And &HFFFF)
        Case WM_MOUSEMOVE
             .MouseMove(hWnd&,LoWord(lParam&),HiWord(lParam&),wParam& And &HFFFF)
        Case WM_KEYDOWN
            .FormKeyDown hWnd&,wParam&,wParam& And &HFFFF
        Case WM_ACTIVATE
             Select Case LoWord(wParam&)
             Case WA_ACTIVE,WA_CLICKACTIVE
                  .Activate(hWnd&)
             Case WA_INACTIVE
                  .DeActivate(hWnd&)
             End Select
        Case WM_SETTEXT
             V = VarPtr$(lParam&)
        Case WM_MOVE
             If .OnDesignFormMove Then CallFunc .OnDesignFormMove,hWnd&,LoWord(lParam&),HiWord(lParam&)
        Case WM_SIZE
             v = LoWord(lParam&)
             SetPropValue(hWnd&,"ClientWidth",v)
             V = HiWord(lParam&)
             SetPropValue(hWnd&,"ClientHeight",v)
             If .OnDesignFormSize Then CallFunc .OnDesignFormSize,hWnd&,LoWord(lParam&),HiWord(lParam&)
        Case WM_WINDOWPOSCHANGED
             MemCpy WP,lParam&,SizeOf(WP)
             v = WP.x
             SetPropValue(hWnd&,"Left",v)
             V = WP.y
             SetPropValue(hWnd&,"Top",v)
             v = WP.cx
             SetPropValue(hWnd&,"Width",v)
             V = WP.cy
             SetPropValue(hWnd&,"Height",v)
        Case WM_SHOWWINDOW
             If wParam& Then
                If .OnDesignFormShow Then CallFunc .OnDesignFormShow,hWnd&
             Else
                If .OnDesignFormHide Then CallFunc .OnDesignFormHide,hWnd&
             End If
        Case WM_CLOSE
             ShowWindow(hWnd&,SW_HIDE)
             Exit Function
        End Select
    End Function

    Function ControlWndProc(hWnd&,Msg&,wParam&,lParam&) As Integer
        Dim V  As Variant
        Dim WP As WINDOWPOS
        Result = CallWindowProc(.GetProc(hWnd&),hWnd&,Msg&,wParam&,lParam&)
        Select Case Msg&
        Case WM_MOUSEMOVE
             SetCapture GetAncestor(hWnd&,GA_ROOTOWNER)
             SetCursor .cr_Arrow
        Case WM_SETFOCUS
             BringWindowToTop GetAncestor(hWnd&,GA_ROOTOWNER)
             Result = 1
             Exit Function
        Case WM_SETTEXT
             V = VarPtr$(lParam&)
             SetPropValue(hWnd&,"Text",v)
        Case WM_SIZE
             v = LoWord(lParam&)
             SetPropValue(hWnd&,"ClientWidth",v)
             V = HiWord(lParam&)
             SetPropValue(hWnd&,"ClientHeight",v)
        Case WM_WINDOWPOSCHANGED
             MemCpy WP,lParam&,SizeOf(WP)
             v = WP.x
             SetPropValue(hWnd&,"Left",v)
             V = WP.y
             SetPropValue(hWnd&,"Top",v)
             v = WP.cx
             SetPropValue(hWnd&,"Width",v)
             V = WP.cy
             SetPropValue(hWnd&,"Height",v)
        End Select
    End Function

    Function DotWndProc(hWnd&,Msg&,wParam&,lParam&) As Integer
        Select Case Msg&
        Case WM_PAINT
             Dim PS As PAINTSTRUCT
             DefInt Dc
             Dim R As RECT
             GetClientRect(hWnd&,R)
             Dc = BeginPaint(hWnd&,PS)
             FillRect Dc,R,.DotBrush
             EndPaint(hWnd&,PS)
        Case WM_MOUSEMOVE
             SetCapture(.DesignForm)
        Case WM_DESTROY
             RemoveProp(hWnd&,"Control")
        End Select
        Result = DefWindowProc(hWnd&,Msg&,wParam&,lParam&)
    End Function

    Public:

    Sub UpdateAll
        DefInt i
        For i = 0 To .FormCount -1
            RedrawWindow .FormList(i),0,0,RDW_INVALIDATE OR RDW_ERASENOW
            UpdateWindow .FormList(i)
        Next i
    End Sub

    Property Set SetGridX(Value As Integer)
        .GridX = Value
        .UpdateAll
    End Property

    Property Set SetGridY(Value As Integer)
        .GridY = Value
        .UpdateAll
    End Property

    Property Set SetGridColor(Value As Integer)
        .GridColor = Value
        .UpdateAll
    End Property

    Property Set SetSelControl(Value As Integer)
        .SelControl = Value
        If .SelControl <> .DesignForm Then
           .MoveDots(.SelControl)
        Else
           .HideDots
        End If
        If .OnChangeSelection Then CallFunc .OnChangeSelection,.SelControl
    End Property

    Property Set SetDesignForm(Value As Integer)
        .DesignForm = Value
    End Property

    Property Set SetShowGrid(Value As Integer)
        .ShowGrid = 1
        .UpdateAll
    End Property

    Property Set SetDesignFormVisible(Value As Integer)
        DefInt CmdShow(2)
        InitArray(CmdShow,SW_HIDE,SW_SHOW)
        .DesignFormVisible = Value
        ShowWindow(.DesignForm,CmdShow(value))
    End Property

    Property Set SetDotColor(Value As Integer)
        DefInt i
        .DotColor = Value
        If .DotBrush Then
           DeleteObject(.DotBrush)
           .DotBrush = CreateSolidBrush(.DotColor)
           For i = 0 To 7
               InvalidateRect .Dots(i),0,1
           Next i
        End If
    End Property

    Sub RegisterDotClass
        .DotBrush = CreateSolidBrush(.DotColor)
        Dim WC As WNDCLASS
        Wc.style         = 8
        Wc.lpszClassName = NewzStr("QDot")
        Wc.lpfnWndProc   = .DotProc
        Wc.hInstance     = GetModuleHandle(0)
        Wc.hbrBackground = .DotBrush
        Wc.hCursor       = LoadCursor(0,IDC_ARROW)
        Wc.cbWndExtra    = 4
        If RegisterClass(Wc) = 0 Then
           MessageDlg ("Can't register QDot class.",1,0,0)
        End If
    End Sub

    Sub Initialization
        DefInt F4
        Bind F4 To This.FormWndProc
        .FormProc = SetNewCallback_4(F4)
        Bind F4 To This.ControlWndProc
        .ControlProc = SetNewCallback_4(F4)
        Bind F4 To This.DotWndProc
        .DotProc = SetNewCallback_4(F4)
    End Sub

    Sub CreateDots(Parent&)
        DefInt i = 0
        Do
             .Dots(i) = CreateWindowEx(0,_
                                "QDot",_
                                 "",_
                                 WS_CHILD Or WS_CLIPSIBLINGS Or WS_CLIPCHILDREN,_
                                 0,_
                                 0,_
                                 6,_
                                 6,_
                                 Parent&,_
                                 0,_
                                 GetModuleHandle(0),_
                                 0)
             i++
        Loop Until i > 7

    End Sub

    Sub FreeForms
        DefInt i
        For i = .FormCount -1 To 0 Step -1
           If .FormList(i) Then DestroyWindow(.FormList(i))
        Next i
    End Sub

    Sub Clear
       .FreeForms
       .FormCount = 0
       ReDim .FormList(.FormCount) As Integer
       .Names.Clear
       .SelControl  = 0
       .SizeControl = 0
       .DesignForm  = 0
       .OverControl = 0
       .BeginX      = 0
       .BeginY      = 0
       .EndX        = 0
       .EndY        = 0
       .NewX        = 0
       .NewY        = 0
       .Down        = 0
       .CanInsert   = 0
       .CanMove     = 0
       .CanSize     = 0
       .ClassName   = ""
       .HideDots
    End Sub

    Sub FreeDots
        DefInt i
        For i = 7 To 0 Step -1
           DestroyWindow(.Dots(i))
        Next i
    End Sub

    Sub Free
        .FreeForms
        .FreeDots
        UnregisterClass "QDot",GetModuleHandle(0)
    End Sub

    End With

    Constructor
    cr_Arrow     = Screen.Cursors(0)
    cr_HandPoint = Screen.Cursors(-21)
    cr_Cross     = Screen.Cursors(-3)
    cr_Size      = Screen.Cursors(-5)
    cr_SizeNESW  = Screen.Cursors(-6)
    cr_SizeNS    = Screen.Cursors(-7)
    cr_SizeNWSE  = Screen.Cursors(-8)
    cr_SizeWE    = Screen.Cursors(-9)
    SnapToGrid   = 1
    GridX        = 4
    GridY        = 4
    GridColor    = 0
    DotColor     = 255
    Initialization
    RegisterDotClass
    End Constructor
End Type

