'QCGI.INC
'2001-2002 Chris Warrington
'    rapidq.basic.c45207@spamgourmet.com
'
'Version: 1.3
'	Date: 09-DEC-2002
'This program is free software; you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation; either version 2 of the License, or
'(at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
'A copy of the GNU General Public Lucense can be found in the file gpl.txt
'
'The GNU General Public License allows you to USE this library in any of your programs,
'but MUST release the source code. If you modify this library, those changes must also
'be released. Be sure to see gpl.txt for the legal mumbo-jumbo

$IFNDEF _QCGI_INC
$DEFINE _QCGI_INC

const cgiInputDefault = 32767
const cgiInputLarge = 65535
const cgiInputSmall = 255
const cgiConvertManual = 0 'False
const cgiConvertAuto = 1   'True

TYPE QCGI EXTENDS QOBJECT
	PUBLIC:
		'*******************************************************
		'* Converts those nasty %xx to their ASCII equivalents *
		'*******************************************************
		FUNCTION HexToAscii(myInput$ AS STRING) AS STRING
			DEFINT my_i% = 0
			DEFSTR my_temp$ = ""

			FOR my_i% = 1 TO LEN(myInput$)
				IF MID$(myInput$, my_i%, 1) = "%" THEN
					my_temp$ = MID$(myInput$, my_i% + 1, 2)
					myInput$ = REPLACESUBSTR$(myInput$, "%" + my_temp$, CHR$(VAL(CONVBASE$(my_temp$, 16, 10))))
				END IF
			NEXT i%

			Result = myInput$
		END FUNCTION
	PRIVATE:
		'***********
		'* Options *
		'***********
		Max_Input AS INTEGER
		Auto_Convert AS INTEGER

		'*********************
		'* Internal Varibles *
		'*********************
		total_pairs& AS INTEGER
		pairs$(256, 2) AS STRING 'keeps the id/value pair
		QueryString AS STRING    'input is stored here

		Initalized AS INTEGER    'a flag to tell if the object has been initalized
		QS_Parsed AS INTEGER     'a flag to tell if the query string has been parsed

		'****************
		'* CGI Varibles *
		'****************
		CGI_Accept AS STRING
		CGI_AuthType AS STRING
		CGI_ContentLength AS INTEGER
		CGI_ContentType AS STRING
		CGI_Cookie AS STRING
		CGI_GatewayInterface AS STRING
		CGI_PathInfo AS STRING
		CGI_PathTranslated AS STRING
		CGI_Referer AS STRING
		CGI_RemoteAddr AS STRING
		CGI_RemoteHost AS STRING
		CGI_RemoteIdent AS STRING
		CGI_RemoteUser AS STRING
		CGI_RequestMethod AS STRING
		CGI_ScriptName AS STRING
		CGI_ServerSoftware AS STRING
		CGI_ServerName AS STRING
		CGI_ServerPort AS STRING
		CGI_ServerProtocol AS STRING
		CGI_UserAgent AS STRING

		'*************************************
		'* Splits the QueryString into pairs *
		'*************************************
		SUB Parse_QS()
			DEFINT my_i& = 0, my_amp& = 0
			DEFSTR my_i$ = ""

			'Count the number of &s in the Query String
			FOR my_i& = 1 TO LEN(QCGI.QueryString)
				IF MID$(QCGI.QueryString, my_i&, 1) = "&" THEN
					my_amp&++
				END IF
			NEXT my_i&

			'Process each pair of values
			my_i& = 1
			WHILE (my_i& <= (my_amp& + 1) AND QCGI.total_pairs& < 256)
				my_i$ = FIELD$(QCGI.QueryString, "&", my_i&)        'Get the pair
				QCGI.pairs$((my_i& - 1), 0) = FIELD$(my_i$, "=", 1) 'Store the id
				QCGI.pairs$((my_i& - 1), 1) = FIELD$(my_i$, "=", 2) 'Store the varible
				IF QCGI.Auto_Convert THEN
					QCGI.HexToAscii(QCGI.pairs$((my_i& - 1) ,1))
					QCGI.pairs$((my_i& - 1) ,1) = REPLACESUBSTR$(QCGI.pairs$((my_i& - 1), 1), "+", " ")   'Convert all +s to ' 's (spaces)
				END IF
				my_i&++
				QCGI.total_pairs&++
			WEND
			'Set flag
			QCGI.QS_Parsed = 1 'True
		END SUB

	PUBLIC:
		constRUCTOR
			CGI_Accept = ENVIRON$("HTTP_ACCEPT")
			CGI_AuthType = ENVIRON$("AUTH_TYPE")
			CGI_ContentLength = VAL(ENVIRON$("CONTENT_LENGTH"))
			CGI_ContentType = ENVIRON$("CONTENT_TYPE")
			CGI_Cookie = ENVIRON$("HTTP_COOKIE")
			CGI_GatewayInterface = ENVIRON$("GATEWAY_INTERFACE")
			CGI_PathInfo = ENVIRON$("PATH_INFO")
			CGI_PathTranslated =ENVIRON$("PATH_TRANSLATED")
			CGI_Referer = ENVIRON$("HTTP_REFERER")
			CGI_RemoteAddr = ENVIRON$("REMOTE_ADDR")
			CGI_RemoteHost = ENVIRON$("REMOTE_HOST")
			CGI_RemoteIdent = ENVIRON$("REMOTE_IDENT")
			CGI_RemoteUser = ENVIRON$("REMOTE_USER")
			CGI_RequestMethod = ENVIRON$("REQUEST_METHOD")
			CGI_ScriptName = ENVIRON$("SCRIPT_NAME")
			CGI_ServerSoftware = ENVIRON$("SERVER_SOFTWARE")
			CGI_ServerName = ENVIRON$("SERVER_NAME")
			CGI_ServerPort = ENVIRON$("SERVER_PORT")
			CGI_ServerProtocol = ENVIRON$("SERVER_PROTOCOL")
			CGI_UserAgent = ENVIRON$("HTTP_USER_AGENT")

			Max_Input = cgiInputDefault
			Auto_Convert = cgiConvertAuto
			total_pairs& = 0
			QueryString = ""

			Initalized = 0 'False
			QS_Parsed = 0 'False
		END constRUCTOR

		'**********************
		'* Accessor Functions *
		'**********************
		FUNCTION GetCGIAccept() AS STRING
			Result = QCGI.CGI_Accept
		END FUNCTION

		FUNCTION GetCGIAuthType() AS STRING
			Result = QCGI.CGI_AuthType
		END FUNCTION

		FUNCTION GetCGIContentLength() AS INTEGER
			Result = QCGI.CGI_ContentLength
		END FUNCTION

		FUNCTION GetCGIContentType() AS STRING
			Result = QCGI.CGI_ContentType
		END FUNCTION

		FUNCTION GetCGICookie() AS STRING
			Result = QCGI.CGI_Cookie
		END FUNCTION

		FUNCTION GetCGIGatewayInterface() AS STRING
			Result = QCGI.CGI_GatewayInterface
		END FUNCTION

		FUNCTION GetCGIPathInfo() AS STRING
			Result = QCGI.CGI_PathInfo
		END FUNCTION

		FUNCTION GetCGIPathTranslated() AS STRING
			Result = QCGI.CGI_PathTranslated
		END FUNCTION

		FUNCTION GetCGIReferer() AS STRING
			Result = QCGI.CGI_Referer
		END FUNCTION

		FUNCTION GetCGIRemoteAddr() AS STRING
			Result = QCGI.CGI_RemoteAddr
		END FUNCTION

		FUNCTION GetCGIRemoteHost() AS STRING
			Result = QCGI.CGI_RemoteHost
		END FUNCTION

		FUNCTION GetCGIRemoteIdent() AS STRING
			Result = QCGI.CGI_RemoteIdent
		END FUNCTION

		FUNCTION GetCGIRemoteUser() AS STRING
			Result = QCGI.CGI_RemoteUser
		END FUNCTION

		FUNCTION GetCGIRequestMethod() AS STRING
			Result = QCGI.CGI_RequestMethod
		END FUNCTION

		FUNCTION GetCGIScriptName() AS STRING
			Result = QCGI.CGI_ScriptName
		END FUNCTION

		FUNCTION GetCGIServerSoftware() AS STRING
			Result = QCGI.CGI_ServerSoftware
		END FUNCTION

		FUNCTION GetCGIServerName() AS STRING
			Result = QCGI.CGI_ServerName
		END FUNCTION

		FUNCTION GetCGIServerPort() AS STRING
			Result = QCGI.CGI_ServerPort
		END FUNCTION

		FUNCTION GetCGIServerProtocol() AS STRING
			Result = QCGI.CGI_ServerProtocol
		END FUNCTION

		FUNCTION GetCGIUserAgent() AS STRING
			Result = QCGI.CGI_UserAgent
		END FUNCTION

		'*************************************
		'* Initalizer (like C++ constructor) *
		'*************************************
		SUB InitCgi(myMaxInput AS INTEGER, myAutoConvert AS INTEGER)
			IF myMaxInput > 0 THEN
				QCGI.Max_input = myMaxInput
			ELSE
				QCGI.Max_input = cgiInputDefault
			END IF

			IF (myAutoConvert = 0 OR myAutoConvert = 1) THEN 'OR IF (myAutoConvert = False OR myAutoConvert = True) THEN
				QCGI.Auto_Convert = myAutoConvert
			ELSE
				QCGI.Auto_Convert = 0
			END IF

			IF UCASE$(QCGI.CGI_RequestMethod) = "POST" THEN
				'Make sure we don't have too much...
				IF QCGI.CGI_ContentLength > QCGI.Max_Input THEN
					QCGI.QueryString = GET$(QCGI.Max_Input)
				ELSE
					QCGI.QueryString = GET$(QCGI.CGI_ContentLength)
				END IF
			ELSE
				IF LEN(ENVIRON$("QUERY_STRING")) > QCGI.Max_Input THEN
					QCGI.QueryString = LEFT$(ENVIRON$("QUERY_STRING"), QCGI.Max_Input)
				ELSE
					QCGI.QueryString = ENVIRON$("QUERY_STRING")
				END IF
			END IF

			QCGI.Initalized = 1 'True
		END SUB

		'*******************************************
		'* Returns the value of a pair based on ID * 
		'*******************************************
		FUNCTION GetValue(myId$ AS STRING) AS STRING
			DEFINT my_i& = 0

			IF QCGI.Initalized = 0 THEN
				Result = "CGI not initalized"
				EXIT FUNCTION
			END IF

			IF NOT(QCGI.QS_Parsed) THEN
				CALL QCGI.Parse_QS
			END IF

			Result = ""
			FOR my_i& = 0 TO QCGI.total_pairs&
				IF myId$ = QCGI.pairs$(my_i&, 0) THEN
					Result = QCGI.pairs$(my_i&, 1)
					EXIT FOR
				END IF
			NEXT my_i&
		END FUNCTION
END TYPE

$ENDIF
  