'$define BOOL LONG 'will need these for D3D header files translated from C++
'$define BOOLEAN LONG 'if you so desire
     $DEFINE HRESULT LONG 'a 32-bit error/warning value- 1-bit flag, 11-bit handle, 4-bit status code, 16-bit information code.


'-- Wrap Types
     CONST D3DRMWRAP_FLAT = 0 'projects the texture along one direction vector
     CONST D3DRMWRAP_CYLINDER = 1 'projects the texture inward to center tangent with one vector
     CONST D3DRMWRAP_SPHERE = 2 'projects the texture inward to center from a sphere
     CONST D3DRMWRAP_CHROME = 3 'uses camera frame (not available in RapidQ) and sphere to calc reflectance
     CONST D3DRMWRAP_SHEET = 4 'not documented by msdn
     CONST D3DRMWRAP_BOX = 5 'tiles the bitmap?
'Type su sv
'Flat 1/w to cover width of object  1/h to cover height of object exactly
'Cylindrical 1* 1/h to cover height of object
'Spherical/chrome 1* 1*
'*Values of <>1 may be used to wrap part of the texture or to tile it but may not be good at the seams.


'***********************************************************************************
'
'  Light types
'
'***********************************************************************************


'-- D3DRMLIGHTTYPE light types, use for QD3DLight.SetLightRGB(lightType, R, G, B)
     CONST D3DRMLIGHT_AMBIENT = 0 'light homogenous in all directions
     CONST D3DRMLIGHT_POINT = 1 'point source
     CONST D3DRMLIGHT_SPOT = 2 'spotlight source.
     CONST D3DRMLIGHT_DIRECTIONAL = 3 'directional source
     CONST D3DRMLIGHT_PARALLELPOINT = 4 'parallel source

'***********************************************************************************
'
'  set rendering quality for the meshbuilder
'
'***********************************************************************************
' - D3DRMSHADEMODE shading modes how do you fill in shading between vertices on the face?
     CONST D3DRMSHADE_FLAT = 0
     CONST D3DRMSHADE_GOURAUD = 1
     CONST D3DRMSHADE_PHONG = 2
     CONST D3DRMSHADE_MASK = 7
     CONST D3DRMSHADE_MAX = 8

'-- fill in faces/vertex mode how do you fill the faces?
     CONST D3DRMFILL_POINTS = 0
     CONST D3DRMFILL_WIREFRAME = 64
     CONST D3DRMFILL_SOLID = 128
     CONST D3DRMFILL_MASK = 448
     CONST D3DRMFILL_MAX = 512


' -- D3DRMLIGHTMODE lighting modes
     CONST D3DRMLIGHT_OFF = 0 * D3DRMSHADE_MAX
     CONST D3DRMLIGHT_ON = 1 * D3DRMSHADE_MAX
     CONST D3DRMLIGHT_MASK = 7 * D3DRMSHADE_MAX
     CONST D3DRMLIGHT_MAX = 8 * D3DRMSHADE_MAX


'-- Shade quality use in QD3DMeshBuilder.SetQuality, can use above alone
     CONST D3DRMRENDER_POINTS = D3DRMSHADE_FLAT + D3DRMLIGHT_OFF + D3DRMFILL_POINTS
     CONST D3DRMRENDER_WIREFRAME = D3DRMSHADE_FLAT + D3DRMLIGHT_OFF + D3DRMFILL_WIREFRAME
     CONST D3DRMRENDER_UNLITFLAT = D3DRMSHADE_FLAT + D3DRMLIGHT_OFF + D3DRMFILL_SOLID
     CONST D3DRMRENDER_FLAT = D3DRMSHADE_FLAT + D3DRMLIGHT_ON + D3DRMFILL_SOLID
     CONST D3DRMRENDER_GOURAUD = D3DRMSHADE_GOURAUD + D3DRMLIGHT_ON + D3DRMFILL_SOLID
     CONST D3DRMRENDER_PHONG = D3DRMSHADE_PHONG + D3DRMLIGHT_ON + D3DRMFILL_SOLID

     CONST D3DRMWIREFRAME_CULL = 1
     CONST D3DRMWIREFRAME_HIDDENLINE = 2

'*********************************************************************************

'-- Renderer modes use for QDXscreen.SetRenderMode They don't have any effect?
     CONST D3DRMRENDERMODE_BLENDEDTRANSPARENCY = 1
     CONST D3DRMRENDERMODE_SORTEDTRANSPARENCY = 2
     CONST D3DRMRENDERMODE_LIGHTINMODELSPACE = 8
     CONST D3DRMRENDERMODE_VIEWDEPENDENTSPECULAR = 16
     CONST D3DRMRENDERMODE_DISABLESORTEDALPHAZWRITE = 32

' the following constants are not described by rapidQ

' -- Textures definitions may not work
     CONST D3DRMTEXTURE_FORCERESIDENT  = &H00000001 'texture should be kept in video memory */
     CONST D3DRMTEXTURE_STATIC  = &H02 'texture will not change */
     CONST D3DRMTEXTURE_DOWNSAMPLEPOINT  = &H00000004 'point filtering should be used when downsampling
     CONST D3DRMTEXTURE_DOWNSAMPLEBILINEAR  = &H00000008 'bilinear filtering should be used when downsampling
     CONST D3DRMTEXTURE_DOWNSAMPLEREDUCEDEPTH  = &H00000010 'reduce bit depth when downsampling
     CONST D3DRMTEXTURE_DOWNSAMPLENONE  = &H00000020 'texture should never be downsampled
     CONST D3DRMTEXTURE_CHANGEDPIXELS  = &H00000040 'pixels have changed
     CONST D3DRMTEXTURE_CHANGEDPALETTE  = &H00000080 'palette has changed
     CONST D3DRMTEXTURE_INVALIDATEONLY  = &H00000100 'dirty regions are invalid

' texture quality (D3DRMTEXTUREQUALITY) use for QDXscreen.SetTextureQuality
     CONST D3DRMTEXTURE_NEAREST = 0 'Choose the nearest pixel in the texture.  (default)
     CONST D3DRMTEXTURE_LINEAR = 1 'Linearly interpolate the four nearest pixels.
     CONST D3DRMTEXTURE_MIPNEAREST = 2 'like D3DRMTEXTURE_NEAREST, but uses the mipmap instead of texture.
     CONST D3DRMTEXTURE_MIPLINEAR = 3 'Like D3DRMTEXTURE_LINEAR, but uses the appropriate mipmap instead of texture
     CONST D3DRMTEXTURE_LINEARMIPNEAREST = 4 'Like D3DRMTEXTURE_MIPNEAREST, but interpolates between the two nearest mipmaps
     CONST D3DRMTEXTURE_LINEARMIPLINEAR = 5 'Like D3DRMTEXTURE_MIPLINEAR, but interpolates between the two nearest mipmaps

' --Shadows
     CONST D3DRMSHADOW_TRUEALPHA  = &H00000001 'shadow should render without artifacts when true alpha is on


' --fog mode, use for QD3DFrame.FogMode and DXscreen.Fog...
     CONST D3DRMFOG_LINEAR = 0 'linear between start and end */
     CONST D3DRMFOG_EXPONENTIAL = 1 ' density * exp(-distance) */
     CONST D3DRMFOG_EXPONENTIALSQUARED = 2 '* density * exp(-distance*distance) */

'--fog color is a DWORD

' --- D3DRMFRAMECONSTRAINT  frame constrain for QD3DFrame.LookAt (F AS QD3DFrame, Constraint AS INTEGER)
     CONST D3DRMCONSTRAIN_Z = 0
     CONST D3DRMCONSTRAIN_Y = 1
     CONST D3DRMCONSTRAIN_X = 2

' -- Combination types  _D3DRMCOMBINETYPE, use for QD3DFrame.AddScale SUB (CombineType%, X#, Y#, Z#)
' Scales a frame's local transformation by (rvX, rvY, rvZ)
'Specifies how to combine the new scale with any current frame transformation.
     CONST D3DRMCOMBINE_REPLACE = 0 'The supplied matrix replaces the frame's current matrix.
     CONST D3DRMCOMBINE_BEFORE = 1 'supplied matrix is multiplied with the frame's current matrix and precedes the current matrix in the calculation.
     CONST D3DRMCOMBINE_AFTER = 2 'supplied matrix is multiplied with the frame's current matrix and follows the current matrix in the calculation.



'textures are obtained by QDXSCREEN.CreateTexture (Tex as QD3DTexture) or QD3DMeshBuilder.SetTexture only?
'There is a QD3DTexture object that should be the same as IDirect3DRMTexture but it doesn't support
' the IDirect3DRMTexture interface or methods such as:
'
'GetColors
'SetColors
'GetDecalOrigin
'GetDecalScale
'GetDecalSize
'GetDecalTransparency
'GetDecalTransparentColor
'SetDecalOrigin
'SetDecalScale
'SetDecalSize
'SetDecalTransparency
'SetDecalTransparentColor
'GetImage
'InitFromFile
'InitFromResource
'InitFromSurface
'AddRef
'QueryInterface
'Release
'Changed
'GetShades
'SetShades